diff --git a/src/backend/commands/ddldeparse.c b/src/backend/commands/ddldeparse.c
index 5878d7e465..7165ead751 100644
--- a/src/backend/commands/ddldeparse.c
+++ b/src/backend/commands/ddldeparse.c
@@ -2990,49 +2855,62 @@ deparse_AlterSeqStmt(Oid objectId, Node *parsetree)
 	if (alterSeqStmt->for_identity)
 		return NULL;
 
+	relation = relation_open(objectId, AccessShareLock);
+
+	/* mark the start of ROOT object */
+	pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+
+	/* create owner jsonb element */
+	role_to_jsonb_element(state, owner);
+
+	new_jsonb_VA(state, "ALTER SEQUENCE %{identity}D %{definition: }s", true, 0);
+
+	insert_identity_object(state, relation->rd_rel->relnamespace,
+						   RelationGetRelationName(relation));
+	relation_close(relation, AccessShareLock);
+
 	seqvalues = get_sequence_values(objectId);
 	seqform = seqvalues->seqform;
 
+	/* sequence definition array object creation, push the key first */
+	insert_jsonb_key(state, "definition");
+
+	/* mark the start of sequence definition array */
+	pushJsonbValue(&state, WJB_BEGIN_ARRAY, NULL);
+
 	foreach(cell, ((AlterSeqStmt *) parsetree)->options)
 	{
 		DefElem    *elem = (DefElem *) lfirst(cell);
-		ObjElem    *newelm;
 
 		if (strcmp(elem->defname, "cache") == 0)
-			newelm = deparse_Seq_Cache(seqform, false);
+			deparse_Seq_Cache_toJsonb(state, seqform, false);
 		else if (strcmp(elem->defname, "cycle") == 0)
-			newelm = deparse_Seq_Cycle(seqform, false);
+			deparse_Seq_Cycle_toJsonb(state, seqform, false);
 		else if (strcmp(elem->defname, "increment") == 0)
-			newelm = deparse_Seq_IncrementBy(seqform, false);
+			deparse_Seq_IncrementBy_toJsonb(state, seqform, false);
 		else if (strcmp(elem->defname, "minvalue") == 0)
-			newelm = deparse_Seq_Minvalue(seqform, false);
+			deparse_Seq_Minvalue_toJsonb(state, seqform, false);
 		else if (strcmp(elem->defname, "maxvalue") == 0)
-			newelm = deparse_Seq_Maxvalue(seqform, false);
+			deparse_Seq_Maxvalue_toJsonb(state, seqform, false);
 		else if (strcmp(elem->defname, "start") == 0)
-			newelm = deparse_Seq_Startwith(seqform, false);
+			deparse_Seq_Startwith_toJsonb(state, seqform, false);
 		else if (strcmp(elem->defname, "restart") == 0)
-			newelm = deparse_Seq_Restart(seqvalues->last_value);
+			deparse_Seq_Restart_toJsonb(state, seqvalues->last_value);
 		else if (strcmp(elem->defname, "owned_by") == 0)
-			newelm = deparse_Seq_OwnedBy(objectId, false);
+			deparse_Seq_OwnedBy_toJsonb(state, objectId, false);
 		else if (strcmp(elem->defname, "as") == 0)
-			newelm = deparse_Seq_As(seqform);
+			deparse_Seq_As_toJsonb(state, seqform);
 		else
 			elog(ERROR, "invalid sequence option %s", elem->defname);
-
-		elems = lappend(elems, newelm);
 	}
 
-	relation = relation_open(objectId, AccessShareLock);
-
-	ret = new_objtree_VA("ALTER SEQUENCE %{identity}D %{definition: }s", 2,
-						 "identity", ObjTypeObject,
-						 new_objtree_for_qualname(relation->rd_rel->relnamespace,
-												  RelationGetRelationName(relation)),
-						 "definition", ObjTypeArray, elems);
+	/* mark the end of sequence definition array */
+	pushJsonbValue(&state, WJB_END_ARRAY, NULL);
 
-	relation_close(relation, AccessShareLock);
+	/* mark the end of ROOT object */
+	value = pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 
-	return ret;
+	return JsonbValueToJsonb(value);
 }
 
 /*
@@ -3045,13 +2923,15 @@ deparse_AlterSeqStmt(Oid objectId, Node *parsetree)
  * OR
  * ALTER %{objtype}s %{if_exists}s %{only}s %{identity}D RENAME COLUMN %{colname}I TO %{newname}I %{cascade}s
  */
-static ObjTree *
+
+static Jsonb *
 deparse_RenameStmt(ObjectAddress address, Node *parsetree)
 {
 	RenameStmt *node = (RenameStmt *) parsetree;
-	ObjTree    *ret;
 	Relation	relation;
 	Oid			schemaId;
+	JsonbParseState *state = NULL;
+	JsonbValue *value;
 
 	/*
 	 * In an ALTER .. RENAME command, we don't have the original name of the
@@ -3066,16 +2946,18 @@ deparse_RenameStmt(ObjectAddress address, Node *parsetree)
 		case OBJECT_TABLE:
 			relation = relation_open(address.objectId, AccessShareLock);
 			schemaId = RelationGetNamespace(relation);
-			ret = new_objtree_VA("ALTER %{objtype}s %{if_exists}s %{identity}D RENAME TO %{newname}I", 4,
-								 "objtype", ObjTypeString,
-								 stringify_objtype(node->renameType, false),
-								 "if_exists", ObjTypeString,
-								 node->missing_ok ? "IF EXISTS" : "",
-								 "identity", ObjTypeObject,
-								 new_objtree_for_qualname(schemaId,
-														  node->relation->relname),
-								 "newname", ObjTypeString,
-								 node->newname);
+
+			pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+			new_jsonb_VA(state, "ALTER %{objtype}s %{if_exists}s %{identity}D RENAME TO %{newname}I", true, 3,
+						 "objtype", jbvString,
+						 stringify_objtype(node->renameType, false),
+						 "if_exists", jbvString,
+						 node->missing_ok ? "IF EXISTS" : "",
+						 "newname", jbvString, node->newname);
+
+			insert_identity_object(state, schemaId, node->relation->relname);
+			value = pushJsonbValue(&state, WJB_END_OBJECT, NULL);
+
 			relation_close(relation, AccessShareLock);
 			break;
 
@@ -3091,61 +2973,161 @@ deparse_RenameStmt(ObjectAddress address, Node *parsetree)
 						 address.objectId);
 				constform = (Form_pg_constraint) GETSTRUCT(constrtup);
 
-				ret = new_objtree_VA("ALTER TABLE %{only}s %{identity}D RENAME CONSTRAINT %{oldname}I TO %{newname}I", 4,
-									"only",  ObjTypeString,
-									node->relation->inh ? "" : "ONLY",
-									"identity", ObjTypeObject,
-									new_objtree_for_qualname_id(RelationRelationId,
-																constform->conrelid),
-									"oldname", ObjTypeString, node->subname,
-									"newname", ObjTypeString, node->newname);
+				pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+				new_jsonb_VA(state, "ALTER TABLE %{only}s %{identity}D RENAME CONSTRAINT %{oldname}I TO %{newname}I", true, 3,
+							 "only", jbvString,
+							 node->relation->inh ? "" : "ONLY",
+							 "oldname", jbvString, node->subname,
+							 "newname", jbvString, node->newname);
+
+				new_jsonb_for_qualname_id(state, RelationRelationId,
+										  constform->conrelid, "identity", false);
+				value = pushJsonbValue(&state, WJB_END_OBJECT, NULL);
+
 				ReleaseSysCache(constrtup);
 			}
 			break;
 
 		case OBJECT_COLUMN:
-			relation = relation_open(address.objectId, AccessShareLock);
-			schemaId = RelationGetNamespace(relation);
-
-			ret = new_objtree_VA("ALTER %{objtype}s", 1,
-								 "objtype", ObjTypeString,
-								 stringify_objtype(node->relationType, false));
-
-			/* Composite types do not support IF EXISTS */
-			if (node->renameType == OBJECT_COLUMN)
-				append_string_object(ret, "%{if_exists}s",
-									 "if_exists",
-									 node->missing_ok ? "IF EXISTS" : "");
-			if (!node->relation->inh)
-				append_string_object(ret, "%{only}s",
-									 "only",
-									 "ONLY");
-			append_object_object(ret, "%{identity}D",
-								 new_objtree_for_qualname(schemaId,
-														  node->relation->relname));
-			append_string_object(ret, "RENAME COLUMN %{colname}I",
-								 "colname", node->subname);
-
-			append_string_object(ret, "TO %{newname}I", "newname",
-								 node->newname);
-
-			if (node->renameType == OBJECT_ATTRIBUTE)
 			{
-				ObjTree	   *tmp_obj = new_objtree("CASCADE");
+				StringInfoData fmtStr;
 
-				if (node->behavior != DROP_CASCADE)
-					append_not_present(tmp_obj, NULL);
-				append_object_object(ret, "%{cascade}s", tmp_obj);
-			}
+				initStringInfo(&fmtStr);
 
-			relation_close(relation, AccessShareLock);
-			break;
+				relation = relation_open(address.objectId, AccessShareLock);
+				schemaId = RelationGetNamespace(relation);
+
+				pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+
+				appendStringInfoString(&fmtStr, "ALTER %{objtype}s");
+
+				new_jsonb_VA(state, NULL, true, 1,
+							 "objtype", jbvString,
+							 stringify_objtype(node->relationType, false));
+
+				/* Composite types do not support IF EXISTS */
+				if (node->renameType == OBJECT_COLUMN)
+				{
+					appendStringInfoString(&fmtStr, " %{if_exists}s");
+					new_jsonb_VA(state, NULL, true, 1,
+								 "if_exists", jbvString,
+								 node->missing_ok ? "IF EXISTS" : "");
+				}
+
+				if (!node->relation->inh)
+				{
+					appendStringInfoString(&fmtStr, " %{only}s");
+					new_jsonb_VA(state, NULL, true, 1, "only", jbvString, "ONLY");
+				}
+
+				appendStringInfoString(&fmtStr, " %{identity}D RENAME COLUMN %{colname}I TO %{newname}I");
+				insert_identity_object(state, schemaId, node->relation->relname);
+				new_jsonb_VA(state, NULL, true, 2,
+							 "colname", jbvString, node->subname,
+							 "newname", jbvString, node->newname);
+
+				if (node->renameType == OBJECT_ATTRIBUTE)
+				{
+					appendStringInfoString(&fmtStr, " %{cascade}s");
+
+					if (node->behavior == DROP_CASCADE)
+						new_jsonb_VA(state, NULL, true, 1, "cascade", jbvString, "CASCADE");
+					else
+					{
+						insert_jsonb_key(state, "cascade");
+						insert_not_present_obj(state, "CASCADE");
+					}
+				}
+
+				/* We have full fmt by now, so add jsonb element for that */
+				fmt_to_jsonb_element(state, fmtStr.data);
+
+				pfree(fmtStr.data);
+
+				value = pushJsonbValue(&state, WJB_END_OBJECT, NULL);
+
+				relation_close(relation, AccessShareLock);
+				break;
+			}
 
 		default:
 			elog(ERROR, "unsupported object type %d", node->renameType);
 	}
 
-	return ret;
+	return JsonbValueToJsonb(value);
+}
+
+/*
+ * Deparse an AlterOwnerStmt (ALTER ... OWNER TO ...).
+ *
+ * Given the object address and the parse tree that created it, return
+ * Jsonb representing the alter command.
+ *
+ * Verbose syntax
+ * ALTER %{objtype}s %{identity}s OWNER TO %{newowner}I
+ */
+static Jsonb *
+deparse_AlterOwnerStmt(ObjectAddress address, Node *parsetree)
+{
+	AlterOwnerStmt *node = (AlterOwnerStmt *) parsetree;
+	JsonbParseState *state = NULL;
+	JsonbValue *value;
+
+	value = new_jsonb_VA(state, "ALTER %{objtype}s %{identity}s OWNER TO %{newowner}I", false, 3,
+						 "objtype", jbvString,
+						 stringify_objtype(node->objectType, false),
+						 "identity", jbvString,
+						 getObjectIdentity(&address, false),
+						 "newowner", jbvString,
+						 get_rolespec_name(node->newowner));
+	return JsonbValueToJsonb(value);
+}
+
+/*
+ * Deparse an AlterObjectSchemaStmt (ALTER ... SET SCHEMA command)
+ *
+ * Given the object address and the parse tree that created it, return an
+ * Jsonb representing the alter command.
+ *
+ * Verbose syntax
+ * ALTER %{objtype}s %{identity}s SET SCHEMA %{newschema}I
+ */
+static Jsonb *
+deparse_AlterObjectSchemaStmt(ObjectAddress address, Node *parsetree,
+							  ObjectAddress old_schema)
+{
+	AlterObjectSchemaStmt *node = (AlterObjectSchemaStmt *) parsetree;
+	char	   *identity;
+	char	   *new_schema = node->newschema;
+	char	   *old_schname;
+	char	   *ident;
+	JsonbParseState *state = NULL;
+	JsonbValue *value;
+
+	/*
+	 * Since the command has already taken place from the point of view of
+	 * catalogs, getObjectIdentity returns the object name with the already
+	 * changed schema.  The output of our deparsing must return the original
+	 * schema name, however, so we chop the schema name off the identity
+	 * string and then prepend the quoted schema name.
+	 *
+	 * XXX This is pretty clunky. Can we do better?
+	 */
+	identity = getObjectIdentity(&address, false);
+	old_schname = get_namespace_name(old_schema.objectId);
+	if (!old_schname)
+		elog(ERROR, "cache lookup failed for schema with OID %u",
+			 old_schema.objectId);
+
+	ident = psprintf("%s%s", quote_identifier(old_schname),
+					 identity + strlen(quote_identifier(new_schema)));
+
+	value = new_jsonb_VA(state, "ALTER %{objtype}s %{identity}s SET SCHEMA %{newschema}I", false, 3,
+						 "objtype", jbvString,
+						 stringify_objtype(node->objectType, false),
+						 "identity", jbvString, ident,
+						 "newschema", jbvString, new_schema);
+	return JsonbValueToJsonb(value);
 }
 
 /*
@@ -3153,11 +3135,12 @@ deparse_RenameStmt(ObjectAddress address, Node *parsetree)
  *
  * This function should cover all cases handled in ProcessUtilitySlow.
  */
-static ObjTree *
-deparse_simple_command(CollectedCommand *cmd, bool *include_owner)
+static Jsonb *
+deparse_simple_command(CollectedCommand *cmd, ddl_deparse_context * context)
 {
 	Oid			objectId;
 	Node	   *parsetree;
+	char	   *owner = context->include_owner ? cmd->role : NULL;
 
 	Assert(cmd->type == SCT_Simple);
 
@@ -3171,26 +3154,25 @@ deparse_simple_command(CollectedCommand *cmd, bool *include_owner)
 	switch (nodeTag(parsetree))
 	{
 		case T_AlterObjectSchemaStmt:
-			*include_owner = false;
+			context->include_owner = false;
 			return deparse_AlterObjectSchemaStmt(cmd->d.simple.address,
 												 parsetree,
 												 cmd->d.simple.secondaryObject);
 
 		case T_AlterOwnerStmt:
-			*include_owner = false;
+			context->include_owner = false;
 			return deparse_AlterOwnerStmt(cmd->d.simple.address, parsetree);
 
 		case T_AlterSeqStmt:
-			return deparse_AlterSeqStmt(objectId, parsetree);
+			return deparse_AlterSeqStmt(objectId, parsetree, owner);
 
 		case T_CreateSeqStmt:
-			return deparse_CreateSeqStmt(objectId, parsetree);
+			return deparse_CreateSeqStmt(objectId, parsetree, owner);
 
 		case T_CreateStmt:
-			return deparse_CreateStmt(objectId, parsetree);
-
+			return deparse_CreateStmt(objectId, parsetree, owner);
 		case T_RenameStmt:
-			*include_owner = false;
+			context->include_owner = false;
 			return deparse_RenameStmt(cmd->d.simple.address, parsetree);
 
 		default:
@@ -3205,14 +3187,14 @@ deparse_simple_command(CollectedCommand *cmd, bool *include_owner)
  * Workhorse to deparse a CollectedCommand.
  */
 char *
-deparse_utility_command(CollectedCommand *cmd, ddl_deparse_context *context)
+deparse_utility_command(CollectedCommand *cmd, ddl_deparse_context * context)
 {
 	OverrideSearchPath *overridePath;
 	MemoryContext oldcxt;
 	MemoryContext tmpcxt;
-	ObjTree    *tree;
 	char	   *command = NULL;
 	StringInfoData str;
+	Jsonb	   *jsonb;
 
 	/*
 	 * Allocate everything done by the deparsing routines into a temp context,
@@ -3246,14 +3228,14 @@ deparse_utility_command(CollectedCommand *cmd, ddl_deparse_context *context)
 	switch (cmd->type)
 	{
 		case SCT_Simple:
-			tree = deparse_simple_command(cmd, &context->include_owner);
+			jsonb = deparse_simple_command(cmd, context);
 			break;
 		case SCT_AlterTable:
-			tree = deparse_AlterRelation(cmd, context);
+			jsonb = deparse_AlterTableStmt(cmd, context);
 			context->include_owner = false;
 			break;
 		case SCT_CreateTableAs:
-			tree = deparse_CreateTableAsStmt(cmd);
+			jsonb = deparse_CreateTableAsStmt(cmd, context);
 			break;
 		default:
 			elog(ERROR, "unexpected deparse node type %d", cmd->type);
@@ -3261,14 +3243,8 @@ deparse_utility_command(CollectedCommand *cmd, ddl_deparse_context *context)
 
 	PopOverrideSearchPath();
 
-	if (tree)
-	{
-		Jsonb	   *jsonb;
-
-		jsonb = context->include_owner ? objtree_to_jsonb(tree, cmd->role) :
-										 objtree_to_jsonb(tree, NULL);
+	if (jsonb)
 		command = JsonbToCString(&str, &jsonb->root, JSONB_ESTIMATED_LEN);
-	}
 
 	/*
 	 * Clean up.  Note that since we created the StringInfo in the caller's
@@ -3280,6 +3256,7 @@ deparse_utility_command(CollectedCommand *cmd, ddl_deparse_context *context)
 	return command;
 }
 
+
 /*
  * Given a CollectedCommand, return a JSON representation of it.
  *
diff --git a/src/backend/replication/logical/ddltrigger.c b/src/backend/replication/logical/ddltrigger.c
index 94161a0497..be1c6b40c9 100644
--- a/src/backend/replication/logical/ddltrigger.c
+++ b/src/backend/replication/logical/ddltrigger.c
@@ -282,12 +282,15 @@ publication_deparse_ddl_command_end(PG_FUNCTION_ARGS)
 		else
 			continue;
 
-		command = deparse_drop_command(obj->objidentity, obj->objecttype,
+		command = deparse_drop_table(obj->objidentity, obj->objecttype,
 									   trigdata->parsetree);
 
 		if (command)
+		{
 			LogLogicalDDLMessage("deparse", obj->address.objectId, cmdtype,
 								 command, strlen(command) + 1);
+			elog(LOG, "COMMAND = %s", command);
+		}
 	}
 
 	return PointerGetDatum(NULL);
diff --git a/src/include/tcop/ddldeparse.h b/src/include/tcop/ddldeparse.h
index 1cceb53662..19b1274859 100644
--- a/src/include/tcop/ddldeparse.h
+++ b/src/include/tcop/ddldeparse.h
@@ -32,7 +32,7 @@ typedef struct
 
 extern char *deparse_utility_command(CollectedCommand *cmd, ddl_deparse_context *context);
 extern char *deparse_ddl_json_to_string(char *jsonb, char** owner);
-extern char *deparse_drop_command(const char *objidentity, const char *objecttype,
-								  Node *parsetree);
+extern char *deparse_drop_table(const char *objidentity, const char *objecttype,
+										   Node *parsetree);
 
 #endif							/* DDL_DEPARSE_H */
diff --git a/src/test/modules/test_ddl_deparse_regress/test_ddl_deparse_regress.c b/src/test/modules/test_ddl_deparse_regress/test_ddl_deparse_regress.c
index 04288c68e0..79036a197f 100644
--- a/src/test/modules/test_ddl_deparse_regress/test_ddl_deparse_regress.c
+++ b/src/test/modules/test_ddl_deparse_regress/test_ddl_deparse_regress.c
@@ -58,10 +58,10 @@ deparse_drop_ddl(PG_FUNCTION_ARGS)
 		PG_RETURN_NULL();
 	}
 
-	command = deparse_drop_command(objidentity_str, objecttype_str, (Node *)&fake_node);
-
+	command = deparse_drop_table(objidentity_str, objecttype_str,
+											(Node *)&fake_node);
 	if (command)
 		PG_RETURN_TEXT_P(cstring_to_text(command));
 
 	PG_RETURN_NULL();
-}
\ No newline at end of file
+}
-- 
2.34.1

